package se.mdh.assist.analysis.plugin.popup.actions;

import java.io.IOException;
import java.lang.reflect.InvocationTargetException;

import javax.swing.SwingUtilities;

import org.eclipse.core.resources.IFile;
import org.eclipse.jface.action.IAction;
import org.eclipse.jface.viewers.ISelection;
import org.eclipse.jface.viewers.StructuredSelection;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.ui.IActionDelegate;
import org.eclipse.ui.IObjectActionDelegate;
import org.eclipse.ui.IWorkbenchPart;
import org.fordiac.ide.model.libraryElement.FBType;
import org.fordiac.ide.typeimport.FBTImporter;
import org.fordiac.ide.typeimport.exceptions.ReferencedTypeNotFoundException;
import org.fordiac.systemmanagement.SystemManager;

import se.mdh.assist.analysis.wcet.Helpers;
import se.mdh.assist.analysis.wcet.data.FBWCETData;
import se.mdh.assist.analysis.wcet.gui.FBWCETPresentationDialog;

public class ViewWCETInfoPopupAction implements IObjectActionDelegate {

	protected Shell shell;
	private IFile selectedFile;
	
	/**
	 * Constructor for Action1.
	 */
	public ViewWCETInfoPopupAction() {
		super();
	}

	/**
	 * @see IObjectActionDelegate#setActivePart(IAction, IWorkbenchPart)
	 */
	public void setActivePart(IAction action, IWorkbenchPart targetPart) {
		shell = targetPart.getSite().getShell();
	}

	/**
	 * @see IActionDelegate#run(IAction)
	 */
	public void run(IAction action) {
		if (selectedFile != null) {
			//TransactionalEditingDomain domain = TransactionalEditingDomain.Factory.INSTANCE.createEditingDomain();
			//domain.setID("se.mdh.assist.analysis");
			try {
				FBType fbType = new FBTImporter().importFBType(selectedFile, SystemManager.getInstance().getPalette(selectedFile.getProject()));
				FBWCETData data;
				try {
					data = Helpers.deserializeFromCommentText(fbType.getComment());
					if (data == null) {
						data = new FBWCETData();
					}
					FBWCETPresentationDialog.DialogRunner dialogRunner = new FBWCETPresentationDialog.DialogRunner(data);
					SwingUtilities.invokeAndWait(dialogRunner);
				} catch (ClassNotFoundException e1) {
					// TODO Auto-generated catch block
					e1.printStackTrace();
				} catch (IOException e1) {
					// TODO Auto-generated catch block
					e1.printStackTrace();
				} catch (InvocationTargetException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				} catch (InterruptedException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
				
				//FbtExporter.saveAsFBTFile(fbType, selectedFile);
				
			} catch (ReferencedTypeNotFoundException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
		
		
	}
	
	/**
	 * @see IActionDelegate#selectionChanged(IAction, ISelection)
	 */
	public void selectionChanged(IAction action, ISelection selection) {
		if (selection instanceof StructuredSelection) {
			StructuredSelection structuredSelection = (StructuredSelection) selection;
			Object selectedObject = structuredSelection.getFirstElement();
			if (selectedObject instanceof IFile) {
				selectedFile = (IFile) selectedObject;
	
				
			}
			
		}
	}
	
	

}
