package se.mdh.assist.analysis.wcet;

import java.util.ArrayList;
import java.util.HashMap;

import org.fordiac.ide.model.libraryElement.CompositeFBType;
import org.fordiac.ide.model.libraryElement.Event;

import se.mdh.assist.analysis.wcet.data.FBWCETData;
import se.mdh.assist.analysis.wcet.data.PeriodWCETData;
import se.mdh.assist.analysis.wcet.data.WCETAnalysisOptions;
import se.mdh.assist.analysis.wcet.data.WCETDataList;

public class CFBAnalysis extends NetworkAnalysis {
	
	protected CompositeFBType cfb;
		
	public CFBAnalysis(CompositeFBType cfb, WCETAnalysisOptions options) {
		super(cfb.getFBNetwork(), options);
		this.cfb = cfb;
	}
	
	@Override
	public FBWCETData doAnalysis() {
				
		HashMap<String, WCETDataList> eventData = doEventAnalysis();
		ArrayList<PeriodWCETData> periodData = doPeriodAnalysis();
		
		return new FBWCETData(eventData, periodData);
	}
	
	protected HashMap<String, WCETDataList> doEventAnalysis() {
		HashMap<String, WCETDataList> result = new HashMap<String, WCETDataList>();
		for (Event inputEvent : cfb.getInterfaceList().getEventInputs()) {
			result.put(inputEvent.getName(), doNetworkAnalysis(inputEvent));
		}
		
		return result;
	}
}
