package se.mdh.assist.analysis.wcet.data;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.HashMap;


public class FBWCETData implements Serializable {
	
	/**
	 * 
	 */
	private static final long serialVersionUID = -2069132277287388739L;
	private HashMap<String, WCETDataList> eventData;
	private ArrayList<PeriodWCETData> periodData;
	
	
	
	public FBWCETData() {
		super();
		eventData = new HashMap<String, WCETDataList>();
		periodData = new ArrayList<PeriodWCETData>();
	}
	
	public FBWCETData(HashMap<String, WCETDataList> eventData,
			ArrayList<PeriodWCETData> periodData) {
		super();
		this.eventData = eventData;
		this.periodData = periodData;
	}

	public HashMap<String, WCETDataList> getEventData() {
		return eventData;
	}
		

	public WCETDataList getEventData(String inputEventName) {
		return eventData.get(inputEventName);
	}
	
	public ArrayList<PeriodWCETData> getPeriodData() {
		return periodData;
	}
	
	@Override
	public String toString() {
		StringBuilder sb = new StringBuilder();
		
		sb.append("<");
		sb.append(eventData);
		sb.append(", ");
		sb.append(periodData);
				
		sb.append(">");
		
		return sb.toString();
	}

		
}
