package se.mdh.assist.analysis.wcet.data;

import java.io.Serializable;
import java.util.ArrayList;


public class PeriodWCETData implements Serializable {
	private static final long serialVersionUID = -4903912792858022372L;
	private int period;
	private WCETDataList data;
	private ArrayList<PeriodOrigin> originStack;
	
	public PeriodWCETData() {
		super();
		this.period = 0;
		data = new WCETDataList();
		originStack = new ArrayList<PeriodWCETData.PeriodOrigin>();
	}
				
	public PeriodWCETData(int period, WCETDataList resultForPeriod) {
		this();
		this.period = period;
		this.data = resultForPeriod;
	}
	
	public PeriodWCETData(int period, WCETDataList resultForPeriod, ArrayList<PeriodOrigin> origin) {
		this(period, resultForPeriod);
		this.originStack = origin;
	}

	public int getPeriod() {
		return period;
	}
	public void setPeriod(int period) {
		this.period = period;
	}
	
	public WCETDataList getData() {
		return data;
	}

	@Override
	public String toString() {
		StringBuilder sb = new StringBuilder();
		
		sb.append("<");
		sb.append(period);
		sb.append(", ");
		sb.append(getOriginStack().toString());
		sb.append(", ");
		sb.append(data.toString());
		sb.append(">");
		
		return sb.toString();
	}
	
	public ArrayList<PeriodOrigin> getOriginStack() {
		if (originStack == null) {
			originStack = new ArrayList<PeriodWCETData.PeriodOrigin>();
		}
		return originStack;
	}
	
	public void addToOriginStack(String typeName, String instanceName) {
		getOriginStack().add(0, new PeriodOrigin(typeName, instanceName));
	}




	public static class PeriodOrigin implements Serializable {
		private static final long serialVersionUID = 3558800390800673845L;
		public String typeName;
		public String instanceName;
		
		public PeriodOrigin(String typeName, String instanceName) {
			super();
			this.typeName = typeName;
			this.instanceName = instanceName;
		}

		@Override
		public String toString() {
			StringBuilder sb = new StringBuilder();
			sb.append(instanceName);
			sb.append("(");
			sb.append(typeName);
			sb.append(")");
			return sb.toString();
		}
		
		
		
	}
}