package se.mdh.assist.analysis.wcet.gui;

import javax.swing.JPanel;
import javax.swing.JSplitPane;
import java.awt.BorderLayout;
import javax.swing.border.TitledBorder;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;
import javax.swing.JScrollPane;
import javax.swing.JButton;

import se.mdh.assist.analysis.wcet.data.FBWCETData;
import se.mdh.assist.analysis.wcet.data.PeriodWCETData;
import se.mdh.assist.analysis.wcet.data.WCETData;
import se.mdh.assist.analysis.wcet.data.WCETDataList;

import java.awt.FlowLayout;
import javax.swing.UIManager;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Map;

public class FBWCETEditPanel extends JPanel {
	private static final long serialVersionUID = -5482158691388277335L;
	private JSplitPane mainSplitPane;
	private JPanel eventDataPanel;
	private JSplitPane eventDataSplitPane;
	private JPanel inputEventPanel;
	private JScrollPane inputEventListScrollPane;
	private InputEventList inputEventList;
	private JPanel inputEventButtonPanel;
	private JButton addInputEventButton;
	private JButton removeInputEventButton;
	
	private FBWCETData data;
	private JPanel eventDataWCETPanel;
	private JSplitPane eventDataSplitPanel2;
	private JScrollPane eventWCETScrollPane;
	private WCETValueList eventWCETValueList;
	private JPanel eventWCETValueButtonPanel;
	private JButton addEventWCETValueButton;
	private JButton removeEventWCETValueButton;
	private JPanel eventWCETOutputInfoPanel;
	private JScrollPane eventWCETOutputInfoScrollPane;
	private OutputInfoList eventWCETOutputInfoList;
	private JPanel eventOutputInfoButtonPanel;
	private JButton addEventOutputInfoButton;
	private JButton removeEventOutputInfoButton;
	private JPanel periodDataPanel;
	private JSplitPane periodSplitPane;
	private JPanel periodWCETOutputInfoPanel;
	private JPanel periodOutputInfoButtonPanel;
	private JButton addPeriodOutputInfoButton;
	private JButton removePeriodOutputInfoButton;
	private JScrollPane periodOutputInfoScrollPane;
	private OutputInfoList periodOutputInfoList;
	private JSplitPane periodDataSplitPanel2;
	private JPanel periodListPanel;
	private JScrollPane periodListScrollPane;
	private JPanel periodListButtonPanel;
	private JButton addPeriodButton;
	private JButton removePeriodButton;
	private PeriodList periodList;
	private JPanel periodDataWCETPanel;
	private JPanel periodDataWCETValueButtonPanel;
	private JButton addPeriodDataWCETValueButton;
	private JButton removePeriodDataWCETValueButton;
	private JScrollPane periodDataWCETValueScrollPane;
	private WCETValueList periodWCETValueList;

	/**
	 * Create the panel.
	 */
	public FBWCETEditPanel() {
		setLayout(new BorderLayout(0, 0));
		add(getMainSplitPane(), BorderLayout.CENTER);
		
		doBinding();
	}
	
	

	private JSplitPane getMainSplitPane() {
		if (mainSplitPane == null) {
			mainSplitPane = new JSplitPane();
			mainSplitPane.setOrientation(JSplitPane.VERTICAL_SPLIT);
			mainSplitPane.setLeftComponent(getEventDataPanel());
			mainSplitPane.setRightComponent(getPeriodDataPanel());
			mainSplitPane.setDividerLocation(200);
		}
		return mainSplitPane;
	}
	private JPanel getEventDataPanel() {
		if (eventDataPanel == null) {
			eventDataPanel = new JPanel();
			eventDataPanel.setBorder(new TitledBorder(null, "Event WCET Data", TitledBorder.LEADING, TitledBorder.TOP, null, null));
			eventDataPanel.setLayout(new BorderLayout(0, 0));
			eventDataPanel.add(getEventDataSplitPane(), BorderLayout.CENTER);
		}
		return eventDataPanel;
	}
	private JSplitPane getEventDataSplitPane() {
		if (eventDataSplitPane == null) {
			eventDataSplitPane = new JSplitPane();
			eventDataSplitPane.setLeftComponent(getEventDataSplitPanel2());
			eventDataSplitPane.setRightComponent(getEventWCETOutputInfoPanel());
		}
		return eventDataSplitPane;
	}
	private JPanel getInputEventPanel() {
		if (inputEventPanel == null) {
			inputEventPanel = new JPanel();
			inputEventPanel.setBorder(new TitledBorder(null, "Input Event", TitledBorder.LEADING, TitledBorder.TOP, null, null));
			inputEventPanel.setLayout(new BorderLayout(5, 5));
			inputEventPanel.add(getInputEventListScrollPane(), BorderLayout.CENTER);
			inputEventPanel.add(getInputEventButtonPanel(), BorderLayout.NORTH);
		}
		return inputEventPanel;
	}
	private JScrollPane getInputEventListScrollPane() {
		if (inputEventListScrollPane == null) {
			inputEventListScrollPane = new JScrollPane();
			inputEventListScrollPane.setViewportView(getInputEventList());
		}
		return inputEventListScrollPane;
	}
	private InputEventList getInputEventList() {
		if (inputEventList == null) {
			inputEventList = new InputEventList();
		}
		return inputEventList;
	}
	private JPanel getInputEventButtonPanel() {
		if (inputEventButtonPanel == null) {
			inputEventButtonPanel = new JPanel();
			FlowLayout flowLayout = (FlowLayout) inputEventButtonPanel.getLayout();
			flowLayout.setAlignment(FlowLayout.RIGHT);
			inputEventButtonPanel.add(getAddInputEventButton());
			inputEventButtonPanel.add(getRemoveInputEventButton());
		}
		return inputEventButtonPanel;
	}
	private JButton getAddInputEventButton() {
		if (addInputEventButton == null) {
			addInputEventButton = new JButton("Add");
			addInputEventButton.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					if (getInputEventList().getCellEditor() != null) {
						getInputEventList().getCellEditor().stopCellEditing();
					}
					int i = 0;
					while (data.getEventData().containsKey("inputEvent"+i)) {
						i++;
					}
					data.getEventData().put("inputEvent"+i, new WCETDataList());
					getInputEventList().update();
				}
			});
		}
		return addInputEventButton;
	}
	private JButton getRemoveInputEventButton() {
		if (removeInputEventButton == null) {
			removeInputEventButton = new JButton("Remove");
			removeInputEventButton.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					int selectedRow = getInputEventList().getSelectedRow();
					if (selectedRow != -1) {
						String selectedEventName = (String) getInputEventList().getValueAt(selectedRow, 0);
						if (getInputEventList().getCellEditor() != null) {
							getInputEventList().getCellEditor().cancelCellEditing();
						}
						data.getEventData().remove(selectedEventName);
						getInputEventList().update();
					}
				}
			});
		}
		return removeInputEventButton;
	}



	public FBWCETData getData() {
		return data;
	}



	public void setData(FBWCETData data) {
		this.data = data;
		getInputEventList().setData(data.getEventData());
		getPeriodList().setData(data.getPeriodData());
	}
	
	protected void doBinding() {
		getInputEventList().getSelectionModel().addListSelectionListener(new ListSelectionListener() {
			@Override
			public void valueChanged(ListSelectionEvent event) {
				if (getInputEventList().getSelectedRow() == -1) {
					getEventWCETValueList().setData(null);
					return;
				}
				String selectedEvent = (String) getInputEventList().getValueAt(getInputEventList().getSelectedRow(), 0);
				//String selectedEvent = getInputEventList().getSelectionModel().ge.getSelectedValue();
				if (selectedEvent == null) {
					getEventWCETValueList().setData(null);
				} else {
					WCETDataList selectedDataList = data.getEventData(selectedEvent);
					getEventWCETValueList().setData(selectedDataList);
				}
			}
		});
		
		getEventWCETValueList().getSelectionModel().addListSelectionListener(new ListSelectionListener() {
			@Override
			public void valueChanged(ListSelectionEvent event) {
				if (getEventWCETValueList().getSelectedRow() == -1) {
					getEventWCETOutputInfoList().setData(null);
					return;
				}
				WCETData selectedWcetData = (WCETData) getEventWCETValueList().getValueAt(getEventWCETValueList().getSelectedRow(), 0);
				//String selectedEvent = getInputEventList().getSelectionModel().ge.getSelectedValue();
				if (selectedWcetData == null) {
					getEventWCETOutputInfoList().setData(null);
				} else {
					getEventWCETOutputInfoList().setData(selectedWcetData.getOutputInfo());
				}
			}
		});
		
		getPeriodList().getSelectionModel().addListSelectionListener(new ListSelectionListener() {
			@Override
			public void valueChanged(ListSelectionEvent event) {
				if (getPeriodList().getSelectedRow() == -1) {
					getPeriodWCETValueList().setData(null);
					return;
				}
				PeriodWCETData selectedPeriodData =  (PeriodWCETData) getPeriodList().getValueAt(getPeriodList().getSelectedRow(), 0);
				//String selectedEvent = getInputEventList().getSelectionModel().ge.getSelectedValue();
				if (selectedPeriodData == null) {
					getPeriodWCETValueList().setData(null);
				} else {
					WCETDataList selectedDataList = selectedPeriodData.getData();
					getPeriodWCETValueList().setData(selectedDataList);
				}
			}
		});
		
		getPeriodWCETValueList().getSelectionModel().addListSelectionListener(new ListSelectionListener() {
			@Override
			public void valueChanged(ListSelectionEvent event) {
				if (getPeriodWCETValueList().getSelectedRow() == -1) {
					getPeriodOutputInfoList().setData(null);
					return;
				}
				WCETData selectedWcetData = (WCETData) getPeriodWCETValueList().getValueAt(getPeriodWCETValueList().getSelectedRow(), 0);
				//String selectedEvent = getInputEventList().getSelectionModel().ge.getSelectedValue();
				if (selectedWcetData == null) {
					getPeriodOutputInfoList().setData(null);
				} else {
					getPeriodOutputInfoList().setData(selectedWcetData.getOutputInfo());
				}
			}
		});
	}
	
	
	private JPanel getEventDataWCETPanel() {
		if (eventDataWCETPanel == null) {
			eventDataWCETPanel = new JPanel();
			eventDataWCETPanel.setBorder(new TitledBorder(UIManager.getBorder("TitledBorder.border"), "WCET values", TitledBorder.LEADING, TitledBorder.TOP, null, null));
			eventDataWCETPanel.setLayout(new BorderLayout(5, 5));
			eventDataWCETPanel.add(getEventWCETValueButtonPanel(), BorderLayout.NORTH);
			eventDataWCETPanel.add(getEventWCETScrollPane(), BorderLayout.CENTER);
		}
		return eventDataWCETPanel;
	}
	private JSplitPane getEventDataSplitPanel2() {
		if (eventDataSplitPanel2 == null) {
			eventDataSplitPanel2 = new JSplitPane();
			eventDataSplitPanel2.setLeftComponent(getInputEventPanel());
			eventDataSplitPanel2.setRightComponent(getEventDataWCETPanel());
		}
		return eventDataSplitPanel2;
	}
	private JScrollPane getEventWCETScrollPane() {
		if (eventWCETScrollPane == null) {
			eventWCETScrollPane = new JScrollPane();
			eventWCETScrollPane.setViewportView(getEventWCETValueList());
		}
		return eventWCETScrollPane;
	}
	private WCETValueList getEventWCETValueList() {
		if (eventWCETValueList == null) {
			eventWCETValueList = new WCETValueList();
		}
		return eventWCETValueList;
	}
	private JPanel getEventWCETValueButtonPanel() {
		if (eventWCETValueButtonPanel == null) {
			eventWCETValueButtonPanel = new JPanel();
			FlowLayout flowLayout = (FlowLayout) eventWCETValueButtonPanel.getLayout();
			flowLayout.setAlignment(FlowLayout.RIGHT);
			eventWCETValueButtonPanel.add(getAddEventWCETValueButton());
			eventWCETValueButtonPanel.add(getRemoveEventWCETValueButton());
		}
		return eventWCETValueButtonPanel;
	}
	private JButton getAddEventWCETValueButton() {
		if (addEventWCETValueButton == null) {
			addEventWCETValueButton = new JButton("Add");
			addEventWCETValueButton.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent arg0) {
					if (getEventWCETValueList().getCellEditor() != null) {
						getEventWCETValueList().getCellEditor().stopCellEditing();
					}
					WCETDataList dataList = getEventWCETValueList().getData();
					if(dataList != null) {
						dataList.add(new WCETData());
						getEventWCETValueList().update();
					}
				}
			});
		}
		return addEventWCETValueButton;
	}
	private JButton getRemoveEventWCETValueButton() {
		if (removeEventWCETValueButton == null) {
			removeEventWCETValueButton = new JButton("Remove");
			removeEventWCETValueButton.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					int selectedRow = getEventWCETValueList().getSelectedRow();
					if (selectedRow != -1) {
						WCETData selectedWcetData = (WCETData) getEventWCETValueList().getValueAt(selectedRow, 0);
						if (getEventWCETValueList().getCellEditor() != null) {
							getEventWCETValueList().getCellEditor().cancelCellEditing();
						}
						getEventWCETValueList().getData().remove(selectedWcetData);
						getEventWCETValueList().update();
					}
				}
			});
		}
		return removeEventWCETValueButton;
	}
	private JPanel getEventWCETOutputInfoPanel() {
		if (eventWCETOutputInfoPanel == null) {
			eventWCETOutputInfoPanel = new JPanel();
			eventWCETOutputInfoPanel.setBorder(new TitledBorder(null, "Output info", TitledBorder.LEADING, TitledBorder.TOP, null, null));
			eventWCETOutputInfoPanel.setLayout(new BorderLayout(0, 0));
			eventWCETOutputInfoPanel.add(getEventWCETOutputInfoScrollPane(), BorderLayout.CENTER);
			eventWCETOutputInfoPanel.add(getEventOutputInfoButtonPanel(), BorderLayout.NORTH);
		}
		return eventWCETOutputInfoPanel;
	}
	private JScrollPane getEventWCETOutputInfoScrollPane() {
		if (eventWCETOutputInfoScrollPane == null) {
			eventWCETOutputInfoScrollPane = new JScrollPane();
			eventWCETOutputInfoScrollPane.setViewportView(getEventWCETOutputInfoList());
		}
		return eventWCETOutputInfoScrollPane;
	}
	private OutputInfoList getEventWCETOutputInfoList() {
		if (eventWCETOutputInfoList == null) {
			eventWCETOutputInfoList = new OutputInfoList();
		}
		return eventWCETOutputInfoList;
	}
	private JPanel getEventOutputInfoButtonPanel() {
		if (eventOutputInfoButtonPanel == null) {
			eventOutputInfoButtonPanel = new JPanel();
			FlowLayout flowLayout = (FlowLayout) eventOutputInfoButtonPanel.getLayout();
			flowLayout.setAlignment(FlowLayout.RIGHT);
			eventOutputInfoButtonPanel.add(getAddEventOutputInfoButton());
			eventOutputInfoButtonPanel.add(getRemoveEventOutputInfoButton());
		}
		return eventOutputInfoButtonPanel;
	}
	private JButton getAddEventOutputInfoButton() {
		if (addEventOutputInfoButton == null) {
			addEventOutputInfoButton = new JButton("Add");
			addEventOutputInfoButton.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					if (getEventWCETOutputInfoList().getCellEditor() != null) {
						getEventWCETOutputInfoList().getCellEditor().stopCellEditing();
					}
					int i = 0;
					Map<String, Integer> map = (HashMap<String, Integer>) getEventWCETOutputInfoList().getData().getMap();
					while (map.containsKey("outputEvent"+i)) {
						i++;
					}
					map.put("outputEvent"+i, 1);
					getEventWCETOutputInfoList().update();
				}
			});
		}
		return addEventOutputInfoButton;
	}
	private JButton getRemoveEventOutputInfoButton() {
		if (removeEventOutputInfoButton == null) {
			removeEventOutputInfoButton = new JButton("Remove");
			removeEventOutputInfoButton.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					int selectedRow = getEventWCETOutputInfoList().getSelectedRow();
					if (selectedRow != -1) {
						String selectedEventName = (String) getEventWCETOutputInfoList().getValueAt(selectedRow, 0);
						if (getEventWCETOutputInfoList().getCellEditor() != null) {
							getEventWCETOutputInfoList().getCellEditor().cancelCellEditing();
						}
						getEventWCETOutputInfoList().getData().getMap().remove(selectedEventName);
						getEventWCETOutputInfoList().update();
					}
				}
			});
		}
		return removeEventOutputInfoButton;
	}
	private JPanel getPeriodDataPanel() {
		if (periodDataPanel == null) {
			periodDataPanel = new JPanel();
			periodDataPanel.setBorder(new TitledBorder(null, "Periodic WCET Data", TitledBorder.LEADING, TitledBorder.TOP, null, null));
			periodDataPanel.setLayout(new BorderLayout(0, 0));
			periodDataPanel.add(getPeriodSplitPane(), BorderLayout.CENTER);
		}
		return periodDataPanel;
	}
	private JSplitPane getPeriodSplitPane() {
		if (periodSplitPane == null) {
			periodSplitPane = new JSplitPane();
			periodSplitPane.setRightComponent(getPeriodWCETOutputInfoPanel());
			periodSplitPane.setLeftComponent(getPeriodDataSplitPanel2());
		}
		return periodSplitPane;
	}
	private JPanel getPeriodWCETOutputInfoPanel() {
		if (periodWCETOutputInfoPanel == null) {
			periodWCETOutputInfoPanel = new JPanel();
			periodWCETOutputInfoPanel.setBorder(new TitledBorder(null, "Output info", TitledBorder.LEADING, TitledBorder.TOP, null, null));
			periodWCETOutputInfoPanel.setLayout(new BorderLayout(0, 0));
			periodWCETOutputInfoPanel.add(getPeriodOutputInfoButtonPanel(), BorderLayout.NORTH);
			periodWCETOutputInfoPanel.add(getPeriodOutputInfoScrollPane(), BorderLayout.CENTER);
		}
		return periodWCETOutputInfoPanel;
	}
	private JPanel getPeriodOutputInfoButtonPanel() {
		if (periodOutputInfoButtonPanel == null) {
			periodOutputInfoButtonPanel = new JPanel();
			FlowLayout flowLayout = (FlowLayout) periodOutputInfoButtonPanel.getLayout();
			flowLayout.setAlignment(FlowLayout.RIGHT);
			periodOutputInfoButtonPanel.add(getAddPeriodOutputInfoButton());
			periodOutputInfoButtonPanel.add(getRemovePeriodOutputInfoButton());
		}
		return periodOutputInfoButtonPanel;
	}
	private JButton getAddPeriodOutputInfoButton() {
		if (addPeriodOutputInfoButton == null) {
			addPeriodOutputInfoButton = new JButton("Add");
			addPeriodOutputInfoButton.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					if (getPeriodOutputInfoList().getCellEditor() != null) {
						getPeriodOutputInfoList().getCellEditor().stopCellEditing();
					}
					int i = 0;
					Map<String, Integer> map = (HashMap<String, Integer>) getPeriodOutputInfoList().getData().getMap();
					while (map.containsKey("outputEvent"+i)) {
						i++;
					}
					map.put("outputEvent"+i, 1);
					getPeriodOutputInfoList().update();
				}
			});
		}
		return addPeriodOutputInfoButton;
	}
	private JButton getRemovePeriodOutputInfoButton() {
		if (removePeriodOutputInfoButton == null) {
			removePeriodOutputInfoButton = new JButton("Remove");
			removePeriodOutputInfoButton.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					int selectedRow = getPeriodOutputInfoList().getSelectedRow();
					if (selectedRow != -1) {
						String selectedEventName = (String) getPeriodOutputInfoList().getValueAt(selectedRow, 0);
						if (getPeriodOutputInfoList().getCellEditor() != null) {
							getPeriodOutputInfoList().getCellEditor().cancelCellEditing();
						}
						getPeriodOutputInfoList().getData().getMap().remove(selectedEventName);
						getPeriodOutputInfoList().update();
					}
				}
			});
		}
		return removePeriodOutputInfoButton;
	}
	private JScrollPane getPeriodOutputInfoScrollPane() {
		if (periodOutputInfoScrollPane == null) {
			periodOutputInfoScrollPane = new JScrollPane();
			periodOutputInfoScrollPane.setViewportView(getPeriodOutputInfoList());
		}
		return periodOutputInfoScrollPane;
	}
	private OutputInfoList getPeriodOutputInfoList() {
		if (periodOutputInfoList == null) {
			periodOutputInfoList = new OutputInfoList();
		}
		return periodOutputInfoList;
	}
	private JSplitPane getPeriodDataSplitPanel2() {
		if (periodDataSplitPanel2 == null) {
			periodDataSplitPanel2 = new JSplitPane();
			periodDataSplitPanel2.setLeftComponent(getPeriodListPanel());
			periodDataSplitPanel2.setRightComponent(getPeriodDataWCETPanel());
		}
		return periodDataSplitPanel2;
	}
	private JPanel getPeriodListPanel() {
		if (periodListPanel == null) {
			periodListPanel = new JPanel();
			periodListPanel.setBorder(new TitledBorder(null, "Periods", TitledBorder.LEADING, TitledBorder.TOP, null, null));
			periodListPanel.setLayout(new BorderLayout(0, 0));
			periodListPanel.add(getPeriodListButtonPanel(), BorderLayout.NORTH);
			periodListPanel.add(getPeriodListScrollPane(), BorderLayout.CENTER);
		}
		return periodListPanel;
	}
	private JScrollPane getPeriodListScrollPane() {
		if (periodListScrollPane == null) {
			periodListScrollPane = new JScrollPane();
			periodListScrollPane.setViewportView(getPeriodList());
		}
		return periodListScrollPane;
	}
	private JPanel getPeriodListButtonPanel() {
		if (periodListButtonPanel == null) {
			periodListButtonPanel = new JPanel();
			periodListButtonPanel.add(getAddPeriodButton());
			periodListButtonPanel.add(getRemovePeriodButton());
		}
		return periodListButtonPanel;
	}
	private JButton getAddPeriodButton() {
		if (addPeriodButton == null) {
			addPeriodButton = new JButton("Add");
			addPeriodButton.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent arg0) {
					if (getPeriodList().getCellEditor() != null) {
						getPeriodList().getCellEditor().stopCellEditing();
					}
					ArrayList<PeriodWCETData> dataList = getPeriodList().getData();
					if(dataList != null) {
						dataList.add(new PeriodWCETData(0, new WCETDataList()));
						getPeriodList().update();
					}
				}
			});
		}
		return addPeriodButton;
	}
	private JButton getRemovePeriodButton() {
		if (removePeriodButton == null) {
			removePeriodButton = new JButton("Remove");
			removePeriodButton.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					int selectedRow = getPeriodList().getSelectedRow();
					if (selectedRow != -1) {
						PeriodWCETData selectedPeriodData = (PeriodWCETData) getPeriodList().getValueAt(selectedRow, 0);
						if (getPeriodList().getCellEditor() != null) {
							getPeriodList().getCellEditor().cancelCellEditing();
						}
						getPeriodList().getData().remove(selectedPeriodData);
						getPeriodList().update();
					}
				}
			});
		}
		return removePeriodButton;
	}
	private PeriodList getPeriodList() {
		if (periodList == null) {
			periodList = new PeriodList();
		}
		return periodList;
	}
	private JPanel getPeriodDataWCETPanel() {
		if (periodDataWCETPanel == null) {
			periodDataWCETPanel = new JPanel();
			periodDataWCETPanel.setBorder(new TitledBorder(UIManager.getBorder("TitledBorder.border"), "WCET value", TitledBorder.LEADING, TitledBorder.TOP, null, null));
			periodDataWCETPanel.setLayout(new BorderLayout(0, 0));
			periodDataWCETPanel.add(getPeriodDataWCETValueButtonPanel(), BorderLayout.NORTH);
			periodDataWCETPanel.add(getPeriodDataWCETValueScrollPane(), BorderLayout.CENTER);
		}
		return periodDataWCETPanel;
	}
	private JPanel getPeriodDataWCETValueButtonPanel() {
		if (periodDataWCETValueButtonPanel == null) {
			periodDataWCETValueButtonPanel = new JPanel();
			FlowLayout flowLayout = (FlowLayout) periodDataWCETValueButtonPanel.getLayout();
			flowLayout.setAlignment(FlowLayout.RIGHT);
			periodDataWCETValueButtonPanel.add(getAddPeriodDataWCETValueButton());
			periodDataWCETValueButtonPanel.add(getRemovePeriodDataWCETValueButton());
		}
		return periodDataWCETValueButtonPanel;
	}
	private JButton getAddPeriodDataWCETValueButton() {
		if (addPeriodDataWCETValueButton == null) {
			addPeriodDataWCETValueButton = new JButton("Add");
			addPeriodDataWCETValueButton.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					if (getPeriodWCETValueList().getCellEditor() != null) {
						getPeriodWCETValueList().getCellEditor().stopCellEditing();
					}
					WCETDataList dataList = getPeriodWCETValueList().getData();
					if(dataList != null) {
						dataList.add(new WCETData());
						getPeriodWCETValueList().update();
					}
				}
			});
		}
		return addPeriodDataWCETValueButton;
	}
	private JButton getRemovePeriodDataWCETValueButton() {
		if (removePeriodDataWCETValueButton == null) {
			removePeriodDataWCETValueButton = new JButton("Remove");
			removePeriodDataWCETValueButton.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					int selectedRow = getPeriodWCETValueList().getSelectedRow();
					if (selectedRow != -1) {
						WCETData selectedWcetData = (WCETData) getPeriodWCETValueList().getValueAt(selectedRow, 0);
						if (getPeriodWCETValueList().getCellEditor() != null) {
							getPeriodWCETValueList().getCellEditor().cancelCellEditing();
						}
						getPeriodWCETValueList().getData().remove(selectedWcetData);
						getPeriodWCETValueList().update();
					}
				}
			});
		}
		return removePeriodDataWCETValueButton;
	}
	private JScrollPane getPeriodDataWCETValueScrollPane() {
		if (periodDataWCETValueScrollPane == null) {
			periodDataWCETValueScrollPane = new JScrollPane();
			periodDataWCETValueScrollPane.setViewportView(getPeriodWCETValueList());
		}
		return periodDataWCETValueScrollPane;
	}
	private WCETValueList getPeriodWCETValueList() {
		if (periodWCETValueList == null) {
			periodWCETValueList = new WCETValueList();
		}
		return periodWCETValueList;
	}



	public void finishAllEdits() {
		if (getEventWCETOutputInfoList().getCellEditor() != null) {
			getEventWCETOutputInfoList().getCellEditor().stopCellEditing();
		}
		if (getEventWCETValueList().getCellEditor() != null) {
			getEventWCETValueList().getCellEditor().stopCellEditing();
		}
		if (getInputEventList().getCellEditor() != null) {
			getInputEventList().getCellEditor().stopCellEditing();
		}

		if (getPeriodOutputInfoList().getCellEditor() != null) {
			getPeriodOutputInfoList().getCellEditor().stopCellEditing();
		}
		if (getPeriodWCETValueList().getCellEditor() != null) {
			getPeriodWCETValueList().getCellEditor().stopCellEditing();
		}
		if (getPeriodList().getCellEditor() != null) {
			getPeriodList().getCellEditor().stopCellEditing();
		}
	}
}
