package se.mdh.assist.analysis.wcet.gui;

import java.awt.BorderLayout;
import java.awt.FlowLayout;

import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JPanel;
import javax.swing.UIManager;
import javax.swing.border.EmptyBorder;

import se.mdh.assist.analysis.wcet.data.FBWCETData;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;

public class FBWCETEditorDialog extends JDialog {
	private static final long serialVersionUID = -2656175499119782612L;

	private final JPanel contentPanel = new JPanel();
	
	protected FBWCETData data;

	private FBWCETEditPanel editPanel;
	
	private boolean resultOk;

	/**
	 * Launch the application.
	 */
	public static void main(String[] args) {
		try {
			FBWCETEditorDialog dialog = new FBWCETEditorDialog();
			dialog.setDefaultCloseOperation(JDialog.DISPOSE_ON_CLOSE);
			dialog.setVisible(true);
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	/**
	 * Create the dialog.
	 */
	public FBWCETEditorDialog() {
		setTitle("WCET Editor");
		resultOk = false;
		setBounds(100, 100, 703, 508);
		getContentPane().setLayout(new BorderLayout());
		contentPanel.setBorder(new EmptyBorder(5, 5, 5, 5));
		getContentPane().add(contentPanel, BorderLayout.CENTER);
		contentPanel.setLayout(new BorderLayout(0, 0));
		{
			editPanel = new FBWCETEditPanel();
			contentPanel.add(editPanel, BorderLayout.CENTER);
		}
		{
			JPanel buttonPane = new JPanel();
			buttonPane.setLayout(new FlowLayout(FlowLayout.RIGHT));
			getContentPane().add(buttonPane, BorderLayout.SOUTH);
			{
				JButton okButton = new JButton("OK");
				okButton.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						resultOk = true;
						setVisible(false);
					}
				});
				okButton.setActionCommand("OK");
				buttonPane.add(okButton);
				getRootPane().setDefaultButton(okButton);
			}
			{
				JButton cancelButton = new JButton("Cancel");
				cancelButton.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent arg0) {
						resultOk = false;
						setVisible(false);
					}
				});
				cancelButton.setActionCommand("Cancel");
				buttonPane.add(cancelButton);
			}
		}
	}

	public FBWCETData getData() {
		return data;
	}

	public void setData(FBWCETData data) {
		this.data = data;
		editPanel.setData(data);
	}

	public boolean isResultOk() {
		return resultOk;
	}

	public void finishAllEdits() {
		editPanel.finishAllEdits();
		
	}
	
	public static class DialogRunner implements Runnable {
		private boolean shouldSave;
		private FBWCETData data;
				
		public DialogRunner(FBWCETData data) {
			super();
			this.data = data;
		}

		@Override
		public void run() {
			
			try {
				UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
			} catch (Exception e) {}
			
			FBWCETEditorDialog dialog = new FBWCETEditorDialog();
			dialog.setData(this.data);
			
			dialog.setModal(true);
			dialog.setVisible(true);
			dialog.finishAllEdits();
			setShouldSave(dialog.isResultOk());
						
		}

		public boolean isShouldSave() {
			return shouldSave;
		}

		protected void setShouldSave(boolean shouldSave) {
			this.shouldSave = shouldSave;
		}

		public FBWCETData getData() {
			return data;
		}

		public void setData(FBWCETData data) {
			this.data = data;
		}
		
		
		
	}
	

}
