package se.mdh.assist.analysis.wcet.gui;

import java.awt.BorderLayout;
import java.awt.FlowLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JPanel;
import javax.swing.UIManager;
import javax.swing.border.EmptyBorder;
import javax.swing.JScrollPane;

import se.mdh.assist.analysis.wcet.data.FBWCETData;

public class FBWCETPresentationDialog extends JDialog {
	private static final long serialVersionUID = -5658787733656660176L;
	private final JPanel contentPanel = new JPanel();
	private WCETDataPresentationTable dataPresentationTable;

	/**
	 * Launch the application.
	 */
	public static void main(String[] args) {
		try {
			FBWCETPresentationDialog dialog = new FBWCETPresentationDialog();
			dialog.setDefaultCloseOperation(JDialog.DISPOSE_ON_CLOSE);
			dialog.setVisible(true);
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	/**
	 * Create the dialog.
	 */
	public FBWCETPresentationDialog() {
		setTitle("WCET Data");
		setBounds(100, 100, 450, 300);
		getContentPane().setLayout(new BorderLayout());
		contentPanel.setBorder(new EmptyBorder(5, 5, 5, 5));
		getContentPane().add(contentPanel, BorderLayout.CENTER);
		contentPanel.setLayout(new BorderLayout(0, 0));
		{
			JScrollPane scrollPane = new JScrollPane();
			contentPanel.add(scrollPane);
			{
				scrollPane.setViewportView(getDataPresentationTable());
			}
		}
		{
			JPanel buttonPane = new JPanel();
			buttonPane.setLayout(new FlowLayout(FlowLayout.RIGHT));
			getContentPane().add(buttonPane, BorderLayout.SOUTH);
			{
				JButton okButton = new JButton("Exit");
				okButton.setActionCommand("OK");
				buttonPane.add(okButton);
				getRootPane().setDefaultButton(okButton);
				okButton.addActionListener(new ActionListener() {
					
					@Override
					public void actionPerformed(ActionEvent arg0) {
						FBWCETPresentationDialog.this.setVisible(false);
						
					}
				});
			}
		}
	}
	
	public WCETDataPresentationTable getDataPresentationTable() {
		if (dataPresentationTable == null) {
			dataPresentationTable = new WCETDataPresentationTable();
			dataPresentationTable.setFillsViewportHeight(true);
		}
		return dataPresentationTable;
	}
	
	public void setData(FBWCETData data) {
		getDataPresentationTable().setData(data);
	}
	
	public static class DialogRunner implements Runnable {
		private FBWCETData data;
				
		public DialogRunner(FBWCETData data) {
			super();
			this.data = data;
		}

		@Override
		public void run() {
			
			try {
				UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
			} catch (Exception e) {}
			
			FBWCETPresentationDialog dialog = new FBWCETPresentationDialog();
			dialog.setData(this.data);
			
			dialog.setModal(true);
			dialog.setVisible(true);
						
		}

		public FBWCETData getData() {
			return data;
		}

		public void setData(FBWCETData data) {
			this.data = data;
		}
		
		
		
	}

}
