package se.mdh.assist.analysis.wcet.gui;

import java.awt.Component;
import java.util.HashMap;

import javax.swing.AbstractCellEditor;

import javax.swing.JTable;
import javax.swing.JTextField;
import javax.swing.event.CellEditorListener;
import javax.swing.event.ChangeEvent;
import javax.swing.table.DefaultTableModel;
import javax.swing.table.TableCellEditor;



public class InputEventList extends JTable {
	private static final long serialVersionUID = -708990043796712309L;
	
	private DefaultTableModel model;
	private HashMap<String, Object> data;
	
	public InputEventList() {
		super(new DefaultTableModel());
		model = (DefaultTableModel) this.getModel();
		
		model.addColumn("WCET");
		this.setTableHeader(null);
		//getColumnModel().getColumn(0).setCellRenderer(new WCETValueListCellRenderer());
		getColumnModel().getColumn(0).setCellEditor(new InputEventListCellEditor());
	}

	public HashMap<String, ?> getData() {
		return data;
	}

	@SuppressWarnings("unchecked")
	public void setData(HashMap<String, ?> data) {
		if (getCellEditor() != null) {
			getCellEditor().stopCellEditing();
		}
		this.data = (HashMap<String, Object>) data;
		update();
		clearSelection();
	}
	
	public void update() {
		
		while (model.getRowCount() > 0) {
			model.removeRow(0);
		}
		if (data != null) {
			for (String event : data.keySet()) {
				Object[] row = {event};
				model.addRow(row);
			}
		} else {
		}
	}
	
	private class InputEventListCellEditor extends AbstractCellEditor implements TableCellEditor {
		private static final long serialVersionUID = 163213774327886400L;
		JTextField field;
		String originalValue;
		

		public InputEventListCellEditor() {
			super();
			field = new JTextField();
			addCellEditorListener( new CellEditorListener() {
				
				@Override
				public void editingStopped(ChangeEvent e) {
					//System.out.println(e.getSource() + ", " + wcetData);
					//wcetData.setWCETValue(Integer.parseInt(field.getText()));
					if (originalValue != null) {
						Object o = data.get(originalValue);
						data.remove(originalValue);
						data.put(field.getText(), o);
					}
				}
				
				@Override
				public void editingCanceled(ChangeEvent e) {
					// TODO Auto-generated method stub
					
				}
			});
		}

		@Override
		public Object getCellEditorValue() {
			return field.getText();
		}

		@Override
		public Component getTableCellEditorComponent(JTable table,
				Object value, boolean isSelected, int row, int column) {
			if (value instanceof String) {
				String eventName = (String) value;
				field.setText(eventName);
				originalValue = eventName;
			} else {
				originalValue = null;
				field.setText("");
			}
			return field;
		}
		
		
		
		
		
	}
}
