package se.mdh.assist.analysis.wcet.gui;

import java.awt.Component;

import javax.swing.AbstractCellEditor;
import javax.swing.JTable;
import javax.swing.JTextField;
import javax.swing.event.CellEditorListener;
import javax.swing.event.ChangeEvent;
import javax.swing.table.DefaultTableModel;
import javax.swing.table.TableCellEditor;
import se.mdh.assist.analysis.wcet.data.OutputInfo;

public class OutputInfoList extends JTable {
	private static final long serialVersionUID = 2950287477993834918L;
	private DefaultTableModel model;
	private OutputInfo data = null;
	
	
	public OutputInfoList() {
		super(new DefaultTableModel());
		this.model = (DefaultTableModel) this.getModel();
		//this.setCellRenderer(new WCETValueListCellRenderer());
		
		model.addColumn("Output event");
		model.addColumn("n");
		//this.setTableHeader(null);
		//getColumnModel().getColumn(0).setCellRenderer(new OutputInfoCellRenderer());
		getColumnModel().getColumn(0).setCellEditor(new OutputInfoListCellEditor());
		getColumnModel().getColumn(1).setCellEditor(new OutputInfoListCellEditor());
	}
	
	public OutputInfo getData() {
		return data;
	}

	public void setData(OutputInfo data) {
		if (getCellEditor() != null) {
			getCellEditor().stopCellEditing();
		}
		this.data = data;
		update();
	}
	
	public void update() {
		while (model.getRowCount() > 0) {
			model.removeRow(0);
		}
		if (data != null) {
			for (String event : data.getMap().keySet()) {
				Object[] row = {event, data.getMap().get(event)};
				model.addRow(row);
			}
		} else {
		}
	}
	
	private class OutputInfoListCellEditor extends AbstractCellEditor implements TableCellEditor {
		private static final long serialVersionUID = 163213774327886400L;
		JTextField field;
		String originalOutputEventName;
		boolean isEditingOccurances;
		int originalNumber;
		
		public OutputInfoListCellEditor() {
			super();
			field = new JTextField();
			originalOutputEventName = null;
			
			
			addCellEditorListener( new CellEditorListener() {
				
				@Override
				public void editingStopped(ChangeEvent e) {
					//System.out.println(e.getSource() + ", " + wcetData);
					//wcetData.setWCETValue(Integer.parseInt(field.getText()));
					if (originalOutputEventName == null) {
						return;
					}
					if (isEditingOccurances) {
						
						try {
							data.getMap().put(originalOutputEventName, Integer.parseInt(field.getText()));
						} catch (Exception ex) {}
					} else if (!field.getText().equals("")) {
						int number = data.getMap().get(originalOutputEventName);
						data.getMap().remove(originalOutputEventName);
						data.getMap().put(field.getText(), number);
					}
					originalOutputEventName = null;
				}
				
				@Override
				public void editingCanceled(ChangeEvent e) {
					// TODO Auto-generated method stub
					
				}
			});
		}

		@Override
		public Object getCellEditorValue() {
			if (isEditingOccurances) {
				try {
					int result = Integer.parseInt(field.getText());
					return result;
				} catch (NumberFormatException nfe) {
					return originalNumber;
				}
			} else {
				if (!field.getText().equals("")) {
					return field.getText();
				} else {
					return originalOutputEventName;
				}
			}
			
		}

		@Override
		public Component getTableCellEditorComponent(JTable table,
				Object value, boolean isSelected, int row, int column) {
			
			if (column == 0) {
				isEditingOccurances = false;
				originalOutputEventName = (String) value;
				field.setText(originalOutputEventName);
			} else {
				isEditingOccurances = true;
				originalOutputEventName = (String) OutputInfoList.this.getValueAt(row, 0);
				originalNumber = (Integer) value;
				field.setText(Integer.toString(originalNumber));
			}
			return field;
		}
		
		
		
		
		
	}

	/*
	private class OutputInfoCellRenderer extends DefaultTableCellRenderer {
		private static final long serialVersionUID = 4585378163464197587L;

		@Override
		public Component getTableCellRendererComponent(JTable table,
				Object value, boolean isSelected, boolean hasFocus, int row,
				int column) {
			Component c = super.getTableCellRendererComponent(table, value, isSelected, hasFocus,
					row, column);
			if (c instanceof OutputInfoCellRenderer) {
				OutputInfoCellRenderer renderer = (OutputInfoCellRenderer) c;
				if (value instanceof String && row == 0) {
				
						//renderer.setText(value);
									
				}
				
			}
			
			return c;
		}
		
	}*/
}
