package se.mdh.assist.analysis.wcet.gui;

import java.awt.BorderLayout;
import java.awt.FlowLayout;

import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JPanel;
import javax.swing.border.EmptyBorder;

import se.mdh.assist.analysis.wcet.data.WCETAnalysisOptions;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;

public class WCETAnalysisOptionsEditorDialog extends JDialog {
	private static final long serialVersionUID = 67456160462213163L;
	private boolean resultOk;
	
	private final JPanel contentPanel = new JPanel();
	private WCETAnalysisOptionsEditPanel analysisOptionsEditPanel;

	/**
	 * Launch the application.
	 */
	public static void main(String[] args) {
		try {
			WCETAnalysisOptionsEditorDialog dialog = new WCETAnalysisOptionsEditorDialog();
			dialog.setDefaultCloseOperation(JDialog.DISPOSE_ON_CLOSE);
			dialog.setVisible(true);
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	/**
	 * Create the dialog.
	 */
	public WCETAnalysisOptionsEditorDialog() {
		resultOk = false;
		setBounds(100, 100, 396, 234);
		getContentPane().setLayout(new BorderLayout());
		contentPanel.setBorder(new EmptyBorder(5, 5, 5, 5));
		getContentPane().add(contentPanel, BorderLayout.CENTER);
		contentPanel.setLayout(new BorderLayout(0, 0));
		{
			analysisOptionsEditPanel = new WCETAnalysisOptionsEditPanel();
			contentPanel.add(analysisOptionsEditPanel);
		}
		{
			JPanel buttonPane = new JPanel();
			buttonPane.setLayout(new FlowLayout(FlowLayout.RIGHT));
			getContentPane().add(buttonPane, BorderLayout.SOUTH);
			{
				JButton okButton = new JButton("OK");
				okButton.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent arg0) {
						resultOk = true;
						setVisible(false);
					}
				});
				okButton.setActionCommand("OK");
				buttonPane.add(okButton);
				getRootPane().setDefaultButton(okButton);
			}
			{
				JButton cancelButton = new JButton("Cancel");
				cancelButton.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						resultOk = false;
						setVisible(false);
					}
				});
				cancelButton.setActionCommand("Cancel");
				buttonPane.add(cancelButton);
			}
		}
		pack();
	}

	public WCETAnalysisOptions getOptions() {
		return analysisOptionsEditPanel.getOptions();
	}

	public void setOptions(WCETAnalysisOptions options) {
		analysisOptionsEditPanel.setOptions(options);
	}

	public boolean isResultOk() {
		return resultOk;
	}

	public void setResultOk(boolean resultOk) {
		this.resultOk = resultOk;
	}

	
	
}
